# frozen_string_literal: true

require 'landline'

$unlocked = false

class Application < Landline::App
  get "/locked" do
    header "content-type", "text/plain"
    "Uh oh, looks like the endpoint is locked!"
  end

  get "/important" do
    redirect "/locked" unless $unlocked
    "Important things here"
  end

  path "/secret" do
    preprocess do
      header "content-type", "text/plain"
      redirect "/locked" unless $unlocked
    end

    get "/bin" do
      "Empty"
    end

    get "/secret" do
      "Very secret data"
    end

    get "/jump" do
      @allowed = true
      jump "/jump"
    end
  end

  get "/jump" do
    redirect "/locked" unless @allowed
    "Congratulations, you've just experienced a cross-handler jump"
  end

  get "/unlock" do
    $unlocked = true
    "Endpoints unlocked"
  end
end

run Application.new
