# frozen_string_literal: true

require 'landline'

class Application < Landline::App
  def initialize(*args)
    puts self
    super(*args)
  end

  preprocess do
    puts Thread.current.inspect
  end

  get "/long" do
    before = request
    sleep 10
    "Request didn't change mid-execution: #{before == request}"
  end

  get "/long2" do
    puts self
    @instance_property = (rand * 1000).floor
    response = "Your magic number is #{@instance_property}\n"
    sleep 20
    response += "Your magic number after waiting 20 seconds is #{@instance_property}"
    response
  end

  get "/magic" do
    @instance_property = (rand * 1000).floor
  end

  postprocess do
    puts "Last value of instance_property: #{@instance_property}"
  end
end

run Application.new
