# frozen_string_literal: true

require 'landline'
require 'landline/extensions/websocket'

class Test < Landline::App
  websocket "/test", version: 7 do |socket|
    socket.on :error do |err|
      puts "Error occured: #{err.inspect}"
      puts err.backtrace
    end
    socket.on :close do
      puts "Client closed read connection"
    end
    socket.write("Hi!")
    puts IO.select([socket]).inspect
    while (response = socket.read)
      if response
        puts "Client wrote: #{response.inspect}"
      else
        puts "Client closed read connection"
      end
      socket.write("You said: #{response}")
    end
    socket.write("Goodbye!")
    socket.close_write
  rescue Exception => e
    puts e.inspect
    puts e.backtrace
  end
end

run Test.new
