# frozen_string_literal: true

require_relative 'dsl/methods_common'
require_relative 'dsl/methods_probe'
require_relative 'dsl/constructors_probe'
require_relative 'util/lookup'

module Landline
  # Execution context for filters and preprocessors.
  class ProcessorContext
    include Landline::DSL::CommonMethods
    include Landline::DSL::ProbeMethods
    include Landline::DSL::ProbeConstructors

    def initialize(path)
      @origin = path
    end

    attr_reader :origin
  end

  # Ephemeral proxy class to which callback execution binds
  class ProcessorOrigin
    def initialize(request, properties)
      @request = request
      @properties = Landline::Util::LookupROProxy.new(properties)
    end

    attr_accessor :response
    attr_reader :request, :properties
  end
end
